# How to Include Metadata in a Cardano Transaction

## What is Transaction Metadata?
Metadata is information that can be added to any Cardano transaction. Metadata can be like a receipt, showing information about the purpose of a transaction. In the [next lesson](/modules/203/2032), you will see how, by following a community standard, you can use transaction metadata to mint Cardano NFTs.

One limitation of transaction metadata is that it cannot be referenced directly in a smart contract. If you want to use data in a smart contract, it is better to use `datum`. Still, transaction metadata can be used creatively, and it can be displayed in an application by using services like [Cardano GraphQL](https://github.com/input-output-hk/cardano-graphql).

For example, at the bottom of this page, there is a list of all metadata that has been posted with the `key` "2023". This data comes from a GraphQL query. In this lesson, you will add your own message to the list below.

<br />
---

## Adding Transaction Metadata with Cardano CLI

If you know how to send a simple transaction with `cardano-cli`, then there is just one more thing you need to know in order to include metadata in your transaction. Take a look at this `transaction build`:

```bash
cardano-cli transaction build \
--babbage-era \
--testnet-magic 1 \
--tx-in $TXIN \
--change-address $SENDERADDRESS \
--metadata-json-file ./metadata/message.json \
--protocol-params-file protocol.json \
--out-file tx-with-metadata.raw
```

We can add the line `--metadata-json-file` and the path to a `.json` file.

Note that in this example, there is no `--tx-out`. This shows how, if your goal is only to put some metadata on-chain, you can send a simple transaction to yourself. When you build a more complex transaction with additional `--tx-in`'s or `--tx-out`'s, you can include metadata in exactly the same way.

### Step 1: Prepare a metadata JSON file:
- On your computer, or in your Demeter.run instance, navigate to the [PPBL 2023 Plutus Template](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template) and pull the latest changes.
- You can now find [send-tx-with-simple-metada.sh](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template/-/blob/main/bash-scripts/send-tx-with-simple-metadata.sh) in `/bash-scripts`
- In the `/bash-scripts` directory, create a new directory called `metadata/`. Then create a new `.json` file called `message.json`:
```bash
cd bash-scripts
mkdir metadata
cd metadata
touch message.json
```

Open the `message.json` file and add this:

```json
{
    "2023": "Hello PPBL 2023!"
}
```

- `2023` is called the `key`
- `"Hello PPBL 2023!"` is called the `value`

Be sure to keep the `key` equal to "2023". You can replace the "Hello PPBL 2023!" message with any message you want, up to 56 characters in length. If you try to include more than 56 characters, you will get an error when building the transaction. Of course, there are ways to write longer strings - you'll see how in the next lesson.

### Step 2: Build, Sign, and Submit a Transaction
- In the [PPBL 2023 Plutus Template](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template), use the provided script [`send-tx-with-simple-metadata.sh`](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template/-/blob/main/bash-scripts/send-tx-with-simple-metadata.sh)
- In `/bash-scripts`, find the new script: [`send-tx-with-simple-metadata.sh`](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template/-/blob/main/bash-scripts/send-tx-with-simple-metadata.sh)
- Open `send-tx-with-simple-metadata.sh` and take a look to see how it works.
- Use the script to complete this lesson.

### Search for TxHash on CardanoScan
After the transaction is successful, try to find it on [Cardanoscan Preprod](https://preprod.cardanoscan.io). Where can you find the Transaction ID for your new transaction?

<br />
---

## Keep Exploring: Add Transaction Metadata with Mesh
In [Lesson 202.3](/modules/202/2023), you saw an example of how to build a minting transaction with Mesh.

Here is how you can add metadata to a simple transaction in Mesh:

```javascript
const senderAddress = addr_test1...

const tx = new Transaction({ initiator: wallet });
tx.sendLovelace(
  senderAddress,
  '1000000'
);
tx.setMetadata(2023, 'Hello PPBL 2023!');
```

- Read these docs: [https://meshjs.dev/apis/transaction#setMetadata](https://meshjs.dev/apis/transaction#setMetadata)
- Try it on your own!
- Bring questions + ideas to [Live Coding](/live-coding)

<br />
---

## Keep Exploring: Add Transaction Metadata with GameChanger
- In [GameChanger Wallet](https://preprod-wallet.gamechanger.finance/dashboard), navigate to the Playground, then choose the "Hello World" demo:

![gc-metadata](/module203/gc-metadata.png)

<br />
---

## Viewing Metadata in an Application
Below, you can see a list of all metadata on Cardano Preprod that uses the key `2023`. If you successfully completed this lesson, you will see your message in the list!

This metadata comes from the following GraphQL query:
```javascript
query TransactionsWithMetadataKey {
  transactions(where: { metadata: { key: { _eq: "2023" } } }, order_by: { includedAt: desc }) {
    hash
    includedAt
    metadata {
      key
      value
    }
  }
}
```

The source code for this component is [here](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-front-end-template-2023/-/blob/module-203-planning/src/components/course-modules/203/cardano/MetadataList.tsx).

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
